#!/bin/bash

#     Obenec 1.0
#     Copyright (C) 2002  Jan Fuchs

#     e-mail: fuky@seif.cz
#     web: http://www.seif.cz

#     Tento program je voln programov vybaven; mete jej it a
# modifikovat podle ustanoven Obecn veejn licence GNU, vydvan Free
# Software Foundation; a to bu verze 2 tto licence anebo (podle vaeho
# uven) kterkoli pozdj verze.

#     Tento program je roziovn v nadji, e bude uiten, avak BEZ
# JAKKOLI ZRUKY; neposkytuj se ani odvozen zruky PRODEJNOSTI anebo
# VHODNOSTI PRO URIT EL.
# Dal podrobnosti hledejte v Obecn veejn licenci GNU.

#    Kopii Obecn veejn licence GNU jste ml obdret spolu s tmto
# programem; pokud se tak nestalo, napite o ni Free Software Foundation,
# Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

function vypis_hlavicka() {
  echo "=== Pkazy ==="
  echo
  echo "nh - nov hra"
  echo "end - konec programu"
  echo "licence - licenn mluvy"
  echo
  echo "=== Obenec 1.0 ==="
}

function vypis_konec() {
  echo -n "Zadej znak nebo pkaz: "
  read retezec
}

function vypis_prohra() {
  clear
  vypis_hlavicka
  head -n130 obesenec.obr | tail -n13
  echo
  echo "Tipovan slovo: $slovo"
  echo "Prohrl(a) jsi."
  echo -n "Zadej pkaz: "
  read retezec
}

function vypis_vyhra() {
  clear
  vypis_hlavicka
  echo
  echo "Tipovan slovo: $slovo"
  echo "Vyhrl(a) jsi."
  echo -n "Zadej pkaz: ";
  read retezec
}

function obes() {
  pozice=$(($chyba * 13))
  head -n$pozice obesenec.obr | tail -n13
}

function vysledek_hry() {
  i=0
  nalezena_cast_slova=""
  while [ $i -lt $slovo_delka ]
  do
    i=$((i + 1))
    znak=$(expr substr $slovo_bez_diakritiky $i 1)
    vypisovany_znak=$(expr substr $slovo $i 1)
    if [ $(expr index $nalezene_znaky $znak) = 0 ]
    then
      nalezena_cast_slova=$nalezena_cast_slova"-"
    else
      nalezena_cast_slova=$nalezena_cast_slova$vypisovany_znak
    fi
  done
}

function kontrola() {
  if [ $konec -eq 10 ]
  then
    echo -n "Mus zadat pkaz: "
    read retezec
  else
    vypis_hlavicka
    if [ $(expr index $slovo_bez_diakritiky $retezec) = 0 ]
    then
      chyba=$(($chyba + 1))
      chybne_znaky=$chybne_znaky$retezec
      if [ $chyba -eq 10 ]
      then
        konec=10
        vypis_prohra
        return;
      fi
      vysledek_hry
    else
      if [ $(expr index $nalezene_znaky $retezec) -eq 0 ]
      then
        nalezene_znaky=$nalezene_znaky$retezec
        vysledek_hry
        if [ $(expr index $nalezena_cast_slova "-") -eq 0 ]
        then
          konec=10
          vypis_vyhra
          return;
        fi
      fi
    fi
    obes
    echo
    echo "Tipovan slovo: "$nalezena_cast_slova
    if ! $([ -z $chybne_znaky ])
    then
      echo "Slovo neobsahuje: "$chybne_znaky
    fi
    vypis_konec
  fi
}

function bez_diakritiky() {
  case $znak_bez_diakritiky in
    "" | "" )
      znak_bez_diakritiky="e"
      ;;
    "" )
      znak_bez_diakritiky="s"
      ;;
    "" )
      znak_bez_diakritiky="c"
      ;;
    "" )
      znak_bez_diakritiky="r"
      ;;
    "" )
      znak_bez_diakritiky="z"
      ;;
    "" )
      znak_bez_diakritiky="y"
      ;;
    "" )
      znak_bez_diakritiky="a"
      ;;
    "" )
      znak_bez_diakritiky="i"
      ;;
    "" )
      znak_bez_diakritiky="d"
      ;;
    "" )
      znak_bez_diakritiky="t"
      ;;
    "" )
      znak_bez_diakritiky="n"
      ;;
    "" )
      znak_bez_diakritiky="o"
      ;;
    "" | "" )
      znak_bez_diakritiky="u"
      ;;
  esac
}

function nova_hra() {
  nahodny_radek=$(($RANDOM % $(wc -l obesenec.dat | cut -c1-7)))
  if [ $nahodny_radek -eq 0 ]
  then
    nahodny_radek=1
  fi
  slovo=$(head -n$nahodny_radek obesenec.dat | tail -n1)
  slovo_delka=$(expr length $slovo)
  nalezene_znaky="!"
  chybne_znaky=""
  slovo_bez_diakritiky=""
  chyba=0
  konec=0
  vypis_hlavicka
  i=0
  echo
  echo -n "Tipovan slovo: "
  while [ $i -lt $slovo_delka ]
  do
    i=$(($i + 1))
    znak_bez_diakritiky=$(expr substr $slovo $i 1)
    bez_diakritiky
    slovo_bez_diakritiky=$slovo_bez_diakritiky$znak_bez_diakritiky
    echo -n "-"
  done
  echo
  vypis_konec
}

function soubory_existence() {
  soubor_neni=0
  if ! $([ -e obesenec.dat ])
  then
    soubor_neni=1
    echo "Soubor obesenec.dat neexistuje!!!"
  fi
  if ! $([ -e obesenec.obr ])
  then
    soubor_neni=1
    echo "Soubor obesenec.obr neexistuje!!!"
  fi
  if [ $soubor_neni -eq 1 ]
  then
    exit
  fi
}

clear
soubory_existence
echo "Obenec verze 1.0, Copyright (C) 2002 Jan Fuchs"
echo
echo "    Obenec je ABSOLUTN BEZ ZRUKY; podrobnosti se dozvte zadnm"
echo "pkazu licence. Jde o voln programov vybaven a jeho en za"
echo "jistch podmnek je vtno; podrobnosti zskte zadnm pkazu licence."
echo
nova_hra

while :
do
  clear
  soubory_existence
  if [ -z "$retezec" ]
  then
    if [ $konec -eq 10 ]
    then
      echo -n "Mus zadat pkaz: "
    else
      echo -n "Mus zadat znak nebo pkaz: "
    fi
    read retezec
  else
    znak_bez_diakritiky=$(echo $retezec | tr A-Z a-z)
    bez_diakritiky
    retezec=$znak_bez_diakritiky
    case "$retezec" in
      "nh" )
        clear
        nova_hra
        ;;
      "end" )
        clear
        exit
        ;;
      "licence" )
        if [ -e licence.cs ]
        then
          less licence.cs
          clear
        else
          echo "Soubor licence.cs nebyl nalezen!!!"
          echo
        fi
        nova_hra
        ;;
      [a-z] )
        kontrola
        ;;
      * )
        echo "Zadal(a) jsi nepovolen znak i pkaz!!!"
        echo -n "Zadej znak nebo pkaz: "
        read retezec
        ;;
    esac
  fi
done
















